//---------------------------------------------------------------------------
//      yfRegistry.cpp
//---------------------------------------------------------------------------
#include "yfRegistry.h"

//----------yfRegistrystaticϐ̒`-------------------------------------

//----------RXgN^---------------------------------------------------
//---------------------------------------------------------------------------
//  ֐Fvoid yfRegistry::yfRegistry(void)
//  ANZXFPublic
//  ́F
//        ^Fvoid
//      OFȂ
//      eFȂ
//  F
//      eFRXgN^
//
//---------------------------------------------------------------------------
yfRegistry::yfRegistry()
  :RegKey(NULL), RootKey(HKEY_CURRENT_USER), StrBuffer(NULL)
{
}
//----------fXgN^-----------------------------------------------------
//---------------------------------------------------------------------------
//  ֐Fvoid yfRegistry::~yfRegistry(void)
//  ANZXFPublic
//  ́F
//        ^Fvoid
//      OFȂ
//      eFȂ
//  F
//      eFfXgN^
//
//---------------------------------------------------------------------------
yfRegistry::~yfRegistry(void)
{
    CloseKey();

	delete[] StrBuffer;
    StrBuffer = NULL;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//      Public
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//      ݒ֌W
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//  ֐Fint yfRegistry::SetRootKey(const HKEY SetKey)
//  ANZXF
//  ́F
//        ^Fconst HKEY
//      OFSetKey
//      eF[gL[
//  óF
//        ^Fint
//      ԒlF0
//      eF
//      ԒlF1
//      eFݒ莸s
//  F
//      eF[gL[̐ݒ
//
//---------------------------------------------------------------------------
int yfRegistry::SetRootKey(const HKEY SetKey)
{
    //-----------------------------------------------------------------------
    //  
    //      XCb`ϐFSetKey
    //      XCb`eFݒ肷郋[gL[
    //          caseFHKEY_CLASSES_ROOT
    //          caseFHKEY_CURRENT_USER
    //          caseFHKEY_LOCAL_MACHINE
    //          caseFHKEY_USERS
    //          caseFHKEY_CURRENT_CONFIG
    //          caseFHKEY_DYN_DATA
    //      eFݒ肷
    //-----------------------------------------------------------------------
    switch ((DWORD)SetKey)
    {
        case HKEY_CLASSES_ROOT:
        case HKEY_CURRENT_USER:
        case HKEY_LOCAL_MACHINE:
        case HKEY_USERS:
        case HKEY_CURRENT_CONFIG:
        case HKEY_DYN_DATA:
            RootKey = SetKey;
            return(0);
     }
     return(1);
}
//---------------------------------------------------------------------------
//  ֐Fint yfRegistry::OpenKey(LPCTSTR SubKey, const bool CanCreate)
//  ANZXF
//  ́F
//        ^FLPCTSTR
//      OFSubKey
//      eFJTuL[
//        ^Fconst bool
//      OFCanCreate
//      eFL[݂Ȃꍇ邩ǂ
//  óF
//        ^Fint
//      ԒlF0
//      eF
//      ԒlF1
//      eFݒ莸s
//  F
//      eFw肵L[J
//
//---------------------------------------------------------------------------
int yfRegistry::OpenKey(LPCTSTR SubKey, const bool CanCreate)
{
    //-----------------------------------------------------------------------
    //  s
    //        FNULL != RegKey
    //      eFłɍ쐬ς
    //      eFG[
    //-----------------------------------------------------------------------
    if (NULL != RegKey)
    {
 		return(1);
    }

    //-----------------------------------------------------------------------
    //      (Initialization)
    //-----------------------------------------------------------------------
    LONG Ret;

    //-----------------------------------------------------------------------
    //  
    //        Ffalse != CanCreate
    //      eF쐬悤Ɏw
    //      eFw肵L[J(RegCreateKeyEx)
    //        Ffalse == CanCreate
    //      eF쐬Ȃ悤Ɏw
    //      eFw肵L[J(RegOpenKeyEx)
    //-----------------------------------------------------------------------
//    if (false != CanCreate)
//    {
//	    Ret = ::RegCreateKeyEx(RootKey, SubKey, 0, KEY_READ, &RegKey);
//    } else {
	    Ret = ::RegOpenKeyEx(RootKey, SubKey, 0, KEY_READ, &RegKey);
//    }
    //-----------------------------------------------------------------------
    //  s
    //        FERROR_SUCCESS != Ret
    //      eFG[̏ꍇ
    //      eFG[
    //-----------------------------------------------------------------------
	if(ERROR_SUCCESS != Ret)
    {
    	return(1);
    }

    return(0);
}
//---------------------------------------------------------------------------
//  ֐Fint yfRegistry::CloseKey(void)
//  ANZXF
//  ́F
//        ^Fvoid
//      OFȂ
//      eFȂ
//  óF
//        ^Fint
//      ԒlF0
//      eF
//      ԒlF1
//      eFݒ莸s
//  F
//      eFw肵L[
//
//---------------------------------------------------------------------------
int yfRegistry::CloseKey(void)
{
    //-----------------------------------------------------------------------
    //  s
    //        FNULL == RegKey
    //      eF쐬ĂȂ
    //      eFԂ
    //-----------------------------------------------------------------------
    if (NULL == RegKey)
    {
 		return(0);
    }

   	::RegCloseKey(RegKey);
    RegKey = NULL;

    return(0);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//      擾֌W
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//  ֐FLPCTSTR yfRegistry::ReadString(LPCTSTR SubKey)
//  ANZXF
//  ́F
//        ^FLPCTSTR
//      OFSubKey
//      eFǂ݂ރTuL[
//  óF
//        ^FLPCTSTR
//      ԒlFNULLȊO
//      eFWXge
//      ԒlF_T("")
//      eFG[
//  F
//      eFWXg當ǂݎ
//
//---------------------------------------------------------------------------
LPCTSTR yfRegistry::ReadString(LPCTSTR SubKey)
{
    LONG Ret;
    DWORD StrLength;
    DWORD Type = REG_SZ;

    Ret = ::RegQueryValueEx(RegKey, SubKey, NULL, &Type, NULL, &StrLength);
    //-----------------------------------------------------------------------
    //  s
    //        FERROR_SUCCESS != Ret
    //      eFG[̏ꍇ
    //      eFG[
    //-----------------------------------------------------------------------
	if(ERROR_SUCCESS != Ret)
    {
        return(_T(""));
    }

    delete[] StrBuffer;
    StrBuffer = new TCHAR[StrLength];
	::RegQueryValueEx(RegKey, SubKey, NULL, &Type, (LPBYTE)StrBuffer, &StrLength);

    return(StrBuffer);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

